/**
 *  Copyright © 2026, Luis Andrés Lange <https://javacomm.net>
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.protocol;

import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import java.lang.reflect.Type;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;



public class CBlockDeserializer implements JsonDeserializer<CBlock> {

  private final static Logger log = LogManager.getLogger(CBlockDeserializer.class);

  @Override
  public CBlock deserialize(JsonElement json, Type type, JsonDeserializationContext context)
      throws JsonParseException {

    CBlock cblock = new CBlock();
    JsonObject jsonobject = json.getAsJsonObject();

    try {
      String pseudoPassword = jsonobject.getAsJsonPrimitive(CBlock.PPASSWORD).getAsString();
      cblock.setPseudoPassword(pseudoPassword);
    }
    catch (NullPointerException e) {
      log.fatal("Protokollfehler: CBlock, das Attribut PPASSWORD ist nicht gesetzt.");
      throw new JsonParseException("Protokollfehler: CBlock, das Attribut PPASSWORD ist nicht gesetzt.");
    }

    try {
      long timestamp = jsonobject.getAsJsonPrimitive(CBlock.TIMESTAMP).getAsLong();
      cblock.setTimestamp(timestamp);
    }
    catch (NullPointerException e) {
      log.fatal("Protokollfehler: CBlock, das Attribut TIMESTAMP ist nicht gesetzt.");
      throw new JsonParseException("Protokollfehler: CBlock, das Attribut TIMESTAMP ist nicht gesetzt.");
    }

    return cblock;
  }
}
